﻿EnableExplicit

XIncludeFile "gDrawing.pbi"

Define mainWin, quit
Global logo

Procedure CanvasUpdate()
    Static rotate.f = 0
    Static s.f      = 0
    Protected scale.f, i.f
    If gStartDrawing(CanvasOutput(1))
        rotate + 5
        s      + 0.15
        i      = Sin(s)*300
        scale  = 1.1 + Sin(s)
        gSetPenImage(logo)
        gSetPenTransform(400,300,rotate*2,scale,scale)
        gBox(0,0,800,600)
        gSetPenSize(5)
        gBezier(0,300,200,i,400,600-i,800,300,RGBA(0,0,0,$FF))
        gRotateAt(400,300,-rotate*0.1)
        gBox(300,200,200,200,RGBA($80,$80,$FF,$AA))
        gDrawingMode(#PB_2DDrawing_Outlined)
        gSetPenSize(2)
        gBox(300,200,200,200,RGBA($FF,$FF,$00,$FF))
        gStopdrawing()
    EndIf
    
    FlipBuffers()
EndProcedure

Define event

If gInit()

    mainWin = OpenWindow(#PB_Any,0,0,800,600,"gDrawing on CanvasGadget",#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    CanvasGadget(1,0,0,800,600)

    LoadImage(1,#PB_Compiler_Home+"\Examples\Sources\Data\PureBasicLogo.bmp")
    logo = gBufferImage(ImageID(1))

    Repeat
        Repeat
            event=WindowEvent()
            If event=#PB_Event_CloseWindow : quit = #True : EndIf
        Until event=0
        CanvasUpdate()
    Until quit=#True

    gEnd()
EndIf

; IDE Options = PureBasic 4.60 (Windows - x86)
; EnableUnicode
; EnableXP
; Executable = example20_x86.exe
; CPU = 5
; DisableDebugger